##########################################################################################
# Phidgets April Fools Keyboard Prank (AprilFools.pyw)
#
# A simple non destructive prank that can be used on a co-worker's keyboard
#
# Copyright 2011 Phidgets Inc.
# This work is licensed under the Creative Commons Attribution 2.5 Canada License.
# To view a copy of this license, visit http://creativecommons.org/licenses/by/2.5/ca/
##########################################################################################

# Import all of the necessary python modules. You will need to install the 
# pywin32 module (http://sourceforge.net/projects/pywin32/) and the pyhook 
# module (http://sourceforge.net/projects/pyhook/files/) if you haven't already.
import pythoncom
import pyHook
import win32serviceutil
import win32service
import win32event
import servicemanager
import socket

# Import the Phidgets python module. These will also need to be installed if you do not 
# have them yet (http://www.phidgets.com/docs/Language_-_Python#Quick_Downloads)
from Phidgets.PhidgetException import *
from Phidgets.Events.Events import *
from Phidgets.Devices.AdvancedServo import AdvancedServo
from Phidgets.Devices.Servo import ServoTypes

def main():
	# Close the phidgets before exiting the program
	def gracefulExit():
		advancedServo.closePhidget()
		sys.exit()

	# Create the phidget advancedServo object
	try: 
		advancedServo = AdvancedServo()   
	except RuntimeError as e:
		print("Runtime Error: %s" % e.message)

	# Open the advancedServo phidget
	try:
		advancedServo.openPhidget()
		advancedServo.waitForAttach(2000)
		print ("%d attached!" % (advancedServo.getSerialNum()))
	except PhidgetException as e:
		print ("Phidget Exception %i: %s" % (e.code, e.details))       
		gracefulExit()

	try:
		# Set the parameters for controlling the servos
		# Servo 1
		advancedServo.setServoType(0,1)
		advancedServo.setPositionMin(0,45)
		advancedServo.setPositionMax(0,135)
		advancedServo.setEngaged(0,True)
		advancedServo.setPosition(0, 90)
		
		# Servo 2
		advancedServo.setServoType(1,1)
		advancedServo.setPositionMin(1,45)
		advancedServo.setPositionMax(1,135)
		advancedServo.setEngaged(1,True)
		advancedServo.setPosition(1, 90)	
	except PhidgetException as e:
		print ("Phidget Exception %i: %s" % (e.code, e.details))     
		gracefulExit()

	# Toggle the position of the selected servo between the min and max range
	def toggleServo(servoNumber):
		if (advancedServo.getPosition(servoNumber) != advancedServo.getPositionMax(servoNumber)):
			advancedServo.setPosition(servoNumber, advancedServo.getPositionMax(servoNumber))
		else:
			advancedServo.setPosition(servoNumber, advancedServo.getPositionMin(servoNumber))

	### The following code is modified from http://www.saurdo.com/07/04/python-keyboard-heatmapper ###
	# Keyboard event handler
	def OnKeyboardEvent(event):
		global ctrl_pressed, f9_pressed, keys_pressed
		
		key =  event.Key
		if(key == "A" or key == "T"):
			#print "servo 1 moves"
			toggleServo(0)
		if(key == "E" or key == "I"):
			#print "servo 2 moves"
			toggleServo(1)
	# Return True to pass the event to other handlers
		return True

	# Create a hook manager
	hm = pyHook.HookManager()
	# Watch for all mouse events
	hm.KeyDown = OnKeyboardEvent
	# Set the hook
	hm.HookKeyboard()
	# Wait forever
	pythoncom.PumpMessages() 

main()